// ----------------------------------------------------------------------------
// main.c  (for myUart project) ('FR6989 Launchpad)
// ----------------------------------------------------------------------------

//***** Header Files **********************************************************
#include <driverlib.h>
#include "myGpio.h"
#include "myClocks.h"
#include "myUart.h"
#include "myLcd.h"
#include "stdio.h"


//***** Prototypes ************************************************************
void initGPIO(void);


//***** Defines ***************************************************************


//***** Global Variables ******************************************************
char val[6];
char gStr[12] = {0x59,0x6F,0x75,0x20,0x43,0x68,0x6F,0x73,0x65,0x3A,0x20,0x30};
unsigned char str[80];

//*****************************************************************************
// Main
//*****************************************************************************
void main (void)
{
	uint16_t size = 0;

    // Stop watchdog timer
    WDT_A_hold( WDT_A_BASE );

    // Initialize GPIO
    initGPIO();

    // Initialize clocks
    initClocks();

    // Initialize LaunchPad LCD
    myLCD_init();

    // Initialize UART (for backchannel communications)
    if ( myUart_init( BACKCHANNEL_UART, 9600, &myUart_Param_9600_8N1_SMCLK8MHz ) >> 0 )
		return;
    else
    	myUart_writeBuf( BACKCHANNEL_UART, "Backchannel opened", NULL, CRLF );

//    // Initialize UART for serial comm with another LaunchPad
//    if ( myUart_init( CHANNEL_0, 9600, &myUart_Param_9600_8N1_SMCLK8MHz ) >> 0 )
//		return;
//    else
//    	myUart_writeBuf( BACKCHANNEL_UART, "Serial Comm opened", NULL, CRLF );

    // Enable interrupts globally
    __enable_interrupt();

    // Write a line of text to the terminal
    myUart_writeBuf( BACKCHANNEL_UART, "Select a number between 1 and 5: ", NULL, CRLF );

    size = 1;
    // Read a character from the terminal (we don't validate it's between 1 and 5)
    myUart_readBuf( BACKCHANNEL_UART, (unsigned char *)val, &size );

    // Convert the ASCII value of the number to an decimal number
    val[0] = (char) ( val[0] - 0x30 );

    // Display the number on the LaunchPad's LCD display
	myLCD_displayNumber( (long) val[0] );

	// Format a string which indicates the selected number
	sprintf( gStr, "You Chose: %d", val[0] );

	// Send a carriage return and linefeed (i.e. go to a new line)
	myUart_writeBuf( BACKCHANNEL_UART, "", NULL, CRLF );

	// Output the "You Chose..." string to the terminal
	myUart_writeBuf( BACKCHANNEL_UART, (unsigned char *)gStr, NULL, CRLF );

//	size = 3;
//	myUart_readBuf( CHANNEL_0, str, &size );
//	myUart_writeBuf( BACKCHANNEL_UART, str, 3, CRLF );


	// Disable all interrupts and enter Low Power Mode 4 (we could have replaced
	// this with a while(1); but that'd have taken more energy
//	__disable_interrupt();
    __low_power_mode_0();

}
